"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.getListeningEvents = exports.LISTEN_PREFIX = void 0;

var _utils = require("../utils");

const LISTEN_PREFIX = '_listen.';
exports.LISTEN_PREFIX = LISTEN_PREFIX;

function* collectListeningEventNames(backend) {
  if (backend === Object.prototype) return;

  for (const k of Object.getOwnPropertyNames(backend)) {
    if (k.startsWith(LISTEN_PREFIX) && (0, _utils.isFunction)(backend[k])) {
      yield k.substring(LISTEN_PREFIX.length);
    }
  }

  yield* collectListeningEventNames(Object.getPrototypeOf(backend));
}

const getListeningEvents = backend => Array.from(new Set(collectListeningEventNames(backend))).sort();

exports.getListeningEvents = getListeningEvents;

var _default = eventName => `${LISTEN_PREFIX}${eventName}`;

exports.default = _default;