"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _utils = require("../utils");

function* collectCommandNames(backend) {
  if (backend === Object.prototype) return;

  for (const k of Object.getOwnPropertyNames(backend)) {
    if (k[0] !== '_' && k !== 'constructor' && (0, _utils.isFunction)(backend[k])) {
      yield k;
    }
  }

  yield* collectCommandNames(Object.getPrototypeOf(backend));
}

var _default = backend => Array.from(new Set(collectCommandNames(backend))).sort();

exports.default = _default;
module.exports = exports.default;