"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _assert = _interopRequireDefault(require("assert"));

var _utils = require("../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = (selectBackend, createBackend, supportedCommands) => {
  const backends = {};
  const result = {};

  for (const type of supportedCommands) {
    result[type] = async (payload, {
      execute
    }) => {
      const selected = await selectBackend(payload, type);
      (0, _assert.default)((0, _utils.isString)(selected));

      if (!backends[selected]) {
        backends[selected] = createBackend(selected);
        (0, _assert.default)(backends[selected], `No backend was created for '${selected}'`);
      }

      const backend = await backends[selected];
      return execute({
        type,
        backend,
        payload
      });
    };
  }

  return result;
};

exports.default = _default;
module.exports = exports.default;