"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _asyncIterator = _interopRequireDefault(require("../async-iterator"));

var _iterate = require("../commands/iterate");

var _map = require("../commands/map");

var _parallel = require("../commands/parallel");

var _iteratorToAsync = _interopRequireDefault(require("../iterator-to-async"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function* _execute(iterable, execute) {
  for (const element of iterable) {
    yield execute(element);
  }
}

var _default = () => ({
  [_iterate.TYPE_ITERATE](payload, {
    iterate
  }) {
    return (0, _iteratorToAsync.default)(iterate(payload));
  },

  [_parallel.TYPE_PARALLEL](payload, {
    execute
  }) {
    return Promise.all(_execute(payload, execute));
  },

  [_map.TYPE_MAP](payload, {
    execute
  }) {
    const {
      collection,
      iteratee
    } = payload;
    return (0, _iteratorToAsync.default)((0, _asyncIterator.default)(collection, item => execute(iteratee(item))));
  }

});

exports.default = _default;
module.exports = exports.default;