"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

class StatisticEntry {
  constructor() {
    this.count = 0;
    this.sum = 0.0;
    this.min = Number.NaN;
    this.max = Number.NaN;
    this.avg = 0.0;
    this.varianceTimesCount = 0.0;
  }

  get variance() {
    return this.varianceTimesCount / this.count;
  }

  addSample(diff) {
    this.count += 1;
    this.sum += diff;
    this.min = Number.isNaN(this.min) ? diff : Math.min(this.min, diff);
    this.max = Number.isNaN(this.max) ? diff : Math.max(this.max, diff);
    const oldAvg = this.avg;
    const diffMinusOldAvg = diff - oldAvg;
    this.avg += diffMinusOldAvg / this.count;
    this.varianceTimesCount += diffMinusOldAvg * (diff - this.avg);
  }

}

exports.default = StatisticEntry;
module.exports = exports.default;