"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.promiseFinally = exports.isCommand = exports.isPromise = exports.isString = exports.isFunction = void 0;

const isFunction = value => typeof value === 'function';

exports.isFunction = isFunction;

const isString = value => typeof value === 'string';

exports.isString = isString;

const isPromise = value => !!value && isFunction(value.then);

exports.isPromise = isPromise;

const isCommand = value => !!value && isString(value.type);

exports.isCommand = isCommand;

const polyfillPromiseFinally = (promise, onFinally) => promise.then(async value => {
  await onFinally();
  return value;
}, async reason => {
  await onFinally();
  throw reason;
});

const promiseFinally = Promise.prototype.finally ? (promise, onFinally) => promise.finally(onFinally) : polyfillPromiseFinally;
exports.promiseFinally = promiseFinally;